<?php
/*
Library for work with user profiles. V1.4. Copyright (C) 2004 Richter
Additional information: http://wpdom.com, richter@wpdom.com
*/

class Profiles_Processor extends DB_Interface {
  var $PP_keeper	= 0;		// Profiles stored in XML-files (0) or in database (1)
  var $PP_table		= 'users';	// Name of table where stored a profiles, if it stores in database
  var $PP_folder	= '';		// Name of folder where stored a profiles, if it stores in XML-files
  var $PP_encode_psw	= TRUE;		// Encrypt (TRUE) or not (FALSE) passwords

  // Addes new profile (registers a new user)
  // Out: 0 if succesfully registered, 1 if login exists, 2 if E-mail exists,
  // 3 if one of the fields is empty, 4 if invalid E-mail
  function profile_add($login, $psw, $lng, $ug, $start_page, $email, $check_email = FALSE)
  {
    $reg_res = 0;
    if (empty($this->PP_folder)) $this->PP_folder = getcwd().'/';
    if (empty($login) or empty($psw) or ($check_email and empty($email))) return 3;
    if ($check_email and !validate_email($email)) return 4;
    // Checking
    if ($this->PP_keeper == 1) {
      $this->SQL = "select id from ".$this->PP_table." where login='$login'";
      if ($this->DB_num_rows($this->DB_db_query()) > 0) return 1;
      if ($check_email) {
        $this->SQL = "select id from ".$this->PP_table." where email='$email'";
        if ($this->DB_num_rows($this->DB_db_query()) > 0) return 2;
      }
    } else {
      if ($dir = @opendir($this->PP_folder)) {
        while (($file = readdir($dir)) !== false) {
          if ($file!='.' && $file!='..') {
            $psfp = @fopen($this->PP_folder."$file","r");
            $dump = fread($psfp,filesize($this->PP_folder."$file"));
            if (get_f($dump,'login') == $login) {$reg_res = 1; break;}
            if ($check_email and get_f($dump,'email') == $email) {$reg_res = 2; break;}
          }
        }
      }
    }
    // Registration
    if ($reg_res == 0) {
      $user_id = uniqid('');
      if ($this->PP_encode_psw) $psw = md5($psw);
      $reg_date = date('Y-m-d H:i:s');
      if ($this->PP_keeper == 1) {
        $this->SQL = "insert into ".$this->PP_table." (id, login, psw, lng, ug, start_page, reg_date, email, host) values('$user_id', '$login', '$psw', '$lng', '$ug', '$start_page', '$reg_date', '$email', '".Get_IP()."')";
        $this->DB_db_query();
      } else {
        $ps_file = $this->PP_folder."$user_id.xml";
        $file_dump = "<?xml version=\"1.0\" encoding=\"Windows-1251\"?>\n<pers_set>\n";
        $file_dump .= "<login>$login</login>\n<psw>$psw</psw>\n<lng>$lng</lng>\n<ug>$ug</ug>\n<start_page>$start_page</start_page>\n<reg_date>$reg_date</reg_date>\n<email>$email</email>\n<host>".Get_IP()."</host>\n";
        $file_dump .= "</pers_set>";
        @touch($ps_file);
        @chmod($ps_file,0777);
        $psfp = fopen($ps_file,"w");
        fwrite($psfp,$file_dump);
        fclose($psfp);
      }
      $reg_res = array('0'=>'0', 'id'=>$user_id);
    } else $reg_res = array('0'=>$reg_res);
    return $reg_res;
  }

  // Updates a profile
  // Out: 0 if succesfully updated, 1 if profile not found,
  // 2 if current ID is not $new_pers_set[id]
  function profile_update($new_pers_set, $cur_id = '', $check_cur_id = FALSE)
  {
    if ($check_cur_id and $new_pers_set[id]!=$cur_id) return 2;
    if ($this->PP_encode_psw and !empty($new_pers_set[psw])) $new_pers_set[psw] = md5($new_pers_set[psw]);
    if ($this->PP_keeper == 1) {
      $this->SQL = "select id from ".$this->PP_table." where id='".$new_pers_set[id]."'";
      if ($this->DB_num_rows($this->DB_db_query()) == 1) {
        if (!empty($new_pers_set[login])) $suf .= (!empty($suf)?', ':'')." login='".$new_pers_set[login]."'";
        if (!empty($new_pers_set[psw])) $suf .= (!empty($suf)?', ':'')." psw='".$new_pers_set[psw]."'";
        if (!empty($new_pers_set[ug])) $suf .= (!empty($suf)?', ':'')." ug='".$new_pers_set[ug]."'";
        if (!empty($new_pers_set[lng])) $suf .= (!empty($suf)?', ':'')." lng='".$new_pers_set[lng]."'";
        if (!empty($new_pers_set[start_page])) $suf .= (!empty($suf)?', ':'')." start_page='".$new_pers_set[start_page]."'";
        if (!empty($new_pers_set[reg_date])) $suf .= (!empty($suf)?', ':'')." reg_date='".$new_pers_set[reg_date]."'";
        if (!empty($new_pers_set[email])) $suf .= (!empty($suf)?', ':'')." email='".$new_pers_set[email]."'";
        if (!empty($new_pers_set[host])) $suf .= (!empty($suf)?', ':'')." host='".$new_pers_set[host]."'";
        if (!empty($suf)) {
          $this->SQL = "update ".$this->PP_table." set $suf where id='".$new_pers_set[id]."'";
          $this->DB_db_query();
        }
        $upd_res = 0;
      } else $upd_res = 1;
    } else {
      $ps_file = $this->PP_folder.$new_pers_set[id].'.xml';
      if (file_exists($ps_file) and $ps_file != $this->PP_folder."default.xml") {
        $psfp = fopen($ps_file,"r");
        $dump = fread($psfp,filesize($ps_file));
        fclose($psfp);
        $fp = fopen($ps_file,"w");
        while (list($key,$val) = each($new_pers_set)) {
          if ($key!='id' and ($key!='psw' or trim($val)!='')) {
            if (preg_match("/<$key>(.*?)<\/$key>/",$dump) == 0)
              $dump = preg_replace("/<\/pers_set>/","<$key>".$new_pers_set[$key]."</$key>\n</pers_set>",$dump);
            else
              $dump = preg_replace("/<$key>(.*?)<\/$key>/", "<$key>".$new_pers_set[$key]."</$key>",$dump);
          }
        }
        fwrite($fp,$dump);
        fclose($fp);
        $upd_res = 0;
      } else $upd_res = 1;
    }
    return $upd_res;
  }

  // Deletes a profile
  // 0 if succesfully deleted, 1 if default profile, 2 if empty ID
  function profile_delete($profile_id)
  {
    if ($profile_id == '') return 2;
    if ($this->PP_keeper == 1) {
      if ($profile_id == 1) return 1;
      $this->SQL = "delete from ".$this->PP_table." where id='".$profile_id."'";
      $this->DB_db_query();
    } else {
      if ($profile_id == 'default') return 1;
      @unlink($this->PP_folder.$profile_id.'.xml');
    }
    return 0;
  }

  // Return profile data by login and password or null otherwise
  function profile_load_by_login($login, $password, $additional_fields = '')
  {
    $pers_set = FALSE;
    if ($this->PP_encode_psw) $password = md5($password);
    if ($this->PP_keeper == 1) {
      $this->SQL = "select id from ".$this->PP_table." where login='$login' and psw='$password'";
      $R = $this->DB_db_query();
      if ($this->DB_num_rows($R) > 0) $pers_set = $this->profile_load_by_id($this->DB_result($R,0,'id'), $additional_fields);
    } else {
      if (empty($this->PP_folder)) $this->PP_folder = getcwd().'/';
      if ($dir = @opendir($this->PP_folder)) {
        while (($file = readdir($dir)) !== false) {
          if ($file!='.' && $file!='..') {
            $psfp=fopen($this->PP_folder."$file","r");
            $dump=fread($psfp,filesize($this->PP_folder."$file"));
            if (get_f($dump,'login')==$login and get_f($dump,'psw')==$password) {
              preg_match_all("/(.*?).xml/",$file,$tmp);
              $pers_set = $this->profile_load_by_id($tmp[1][0], $additional_fields);
              break;
            }
          }
        }
      }
    }
    return $pers_set;
  }

  // Return profile data by id
  function profile_load_by_id($profile_id, $additional_fields = '')
  {
    unset($pers_set);
    if ($this->PP_keeper == 1) {
      $this->SQL = "select * from ".$this->PP_table." where id='$profile_id'";
      $R = $this->DB_db_query();
      if ($this->DB_num_rows($R) == 1) {
        $pers_set[id]		= $this->DB_result($R,0,'id');
        $pers_set[login]	= $this->DB_result($R,0,'login');
        $pers_set[psw]		= $this->DB_result($R,0,'psw');
        $pers_set[lng]		= $this->DB_result($R,0,'lng');
        $pers_set[ug]		= $this->DB_result($R,0,'ug');
        $pers_set[start_page]	= $this->DB_result($R,0,'start_page');
        $pers_set[reg_date]	= $this->DB_result($R,0,'reg_date');
        $pers_set[email]	= $this->DB_result($R,0,'email');
        $pers_set[host]	= $this->DB_result($R,0,'host');
        setcookie ("ps_start_page",$this->DB_result($R,0,'start_page'),time()+2592000);
      }
    } else {
      $ps_file = $this->PP_folder.$profile_id.'.xml';
      if (file_exists($ps_file)) {
        $psfp = fopen($ps_file,"r");
        $dump = fread($psfp,filesize($ps_file));
        $pers_set[id]		= $profile_id;
        $pers_set[login]	= get_f($dump,'login');
        $pers_set[psw]		= get_f($dump,'psw');
        $pers_set[lng]		= get_f($dump,'lng');
        $pers_set[ug]		= get_f($dump,'ug');
        $pers_set[start_page]	= get_f($dump,'start_page');
        $pers_set[reg_date]	= get_f($dump,'reg_date');
        $pers_set[email]	= get_f($dump,'email');
        $pers_set[host]		= get_f($dump,'host');
        setcookie ("ps_start_page",get_f($dump,'start_page'),time()+2592000);
        if (is_array($additional_fields)) {
          foreach ($additional_fields as $val)
            $pers_set[$val]	= get_f($dump,$val);
        }
      }
    }
    return $pers_set;
  }

  // Send letter with pasword by E-mail (only for non-encrypted passwords)
  // Input: login or E-mail address
  // Out: 0 if OK, 1 if profile not found, 1 if passwords is encrypted
  function profile_remember_password($login = '', $email = '')
  {
    if ($this->PP_encode_psw) return 2;
    if ($this->PP_keeper == 1) {
      $this->SQL = "select * from ".$this->PP_table." where 
        (login='$login' and login!='') or (email='$email' and email!='')";
      $R = $this->DB_db_query();
      if ($this->DB_num_rows($R) > 0) {
        $found = 1;
        $email = $this->DB_result($R,0,'email');
        $psw = $this->DB_result($R,0,'psw');
      }
    } else {
      if (empty($this->PP_folder)) $this->PP_folder = getcwd().'/';
      if ($dir = @opendir($this->PP_folder)) {
        while (($file = readdir($dir)) !== false) {
          if ($file!='.' && $file!='..') {
            $psfp = @fopen($this->PP_folder."$file","r");
            $dump = fread($psfp,filesize($this->PP_folder."$file"));
            if ((get_f($dump,'login')==$login and !empty($login)) or
              (get_f($dump,'email')==$email and !empty($email))) {
              $found = 1;
              $email = get_f($dump,'email');
              $psw = get_f($dump,'psw');
              break;
            }
          }
        }
      }
    }
    if ($found) {
      $mail = new Mail_sender;
      $mail->from_addr = '';
      $mail->from_name = '';
      $mail->to = $email;
      $mail->subj = 'Password';
      $mail->body = 'Your password: '.$psw;
      $mail->priority = 3;
      $mail->send_mail();
      return 0;
    } else return 1;
  }
}
?>